# SNAP Direct Debit

This API is used to direct debit payment in SNAP standard for route payment.

<table data-header-hidden><thead><tr><th width="176"></th><th></th></tr></thead><tbody><tr><td><strong>URL Path</strong></td><td><a href="https://debit-sandbox.co.id/v1.0/debit/payment-host-to-host">https://debit-sandbox.co.id/v1.0/debit/payment-host-to-host</a></td></tr><tr><td><strong>Method</strong></td><td>POST</td></tr></tbody></table>

## Request Parameter

The parameters that must be provided by the merchant system to be accessed by the Faspay system are as follows:

<table><thead><tr><th width="279">SNAP Parameter</th><th width="173">Data Type</th><th width="92">M/O/C</th><th>Description</th></tr></thead><tbody><tr><td>partnerReferenceNo</td><td>String (32)</td><td>M</td><td><p>Transaction identifier on</p><p>service consumer system</p></td></tr><tr><td>bankCardToken</td><td>String (560)</td><td>M</td><td><p>Card token for payment.</p><p> </p><p>Notes:</p><p>Used only for payment channel BRI Direct Debit</p></td></tr><tr><td>merchantId</td><td>String (5)</td><td>M </td><td>Merchant identifier that is unique per each merchant</td></tr><tr><td>amount</td><td>Object</td><td>O</td><td>An object that contains information about an amount or value within a specific context.</td></tr><tr><td>     value</td><td>String (ISO4217) (16,2)</td><td>M</td><td><p>Net amount of the transaction. If it's IDR then value includes 2 decimal digits.</p><p>e.g. IDR 10.000,- will be placed with 10000.00</p></td></tr><tr><td>     currency</td><td>String (3)</td><td>M</td><td>Currency</td></tr><tr><td>validUpTo</td><td>String (25)</td><td>M</td><td>The time when the payment will be automatically expired. ISO 8601</td></tr><tr><td>additionalInfo</td><td>Object</td><td>O</td><td>Additional information</td></tr><tr><td>channelCode</td><td>String (32)</td><td>M </td><td><p>Payment Channel Code</p><p> </p><p>List Channel Code:</p><p>814: Maybank2U</p><p>704: SAKUKU</p><p>714: BRI Direct Debit</p><p>713: Shopeepay App</p><p>716: Linkaja App</p><p>812: OVO</p><p>819: DANA</p><p>700: CIMB Clicks</p><p>701: D-Bank Pro</p><p>401: BRI E-PAY</p><p>405: BCA KlikPay</p><p>302: LinkAja</p><p>722: DANA Subs</p><p>720: OVO OpenAPI</p></td></tr><tr><td>billDate</td><td>String (25)</td><td>M </td><td><p>Transaction/ Order Date</p><p>ISO 8601</p></td></tr><tr><td>billDescription</td><td>String (128)</td><td>M </td><td>Bill description</td></tr><tr><td>phoneNo</td><td>String (30)</td><td>C</td><td><p>Customer Phone Number</p><p> </p><p><strong>Notes:</strong></p><p>Mandatory for payment channel OVO Tokenized</p></td></tr><tr><td>route</td><td>Object</td><td>O</td><td> </td></tr><tr><td>     owner</td><td>Alphanumeric (32) </td><td>O</td><td><p>Registered partner id that owns/generates the transaction. </p><p> </p><p>Note<strong>s:</strong></p><ul><li>1 transaction only can contain 1 owner. </li><li>If null, then the remaining transaction amount will belong to the merchant’s Sendme balance. </li></ul></td></tr><tr><td>    partnerId</td><td>Alphanumeric (32) </td><td>O</td><td>Merchant partner id number.</td></tr><tr><td>    partnerAmount</td><td>Numeric (15) </td><td>C</td><td>Disbursement amount to partner.  </td></tr></tbody></table>

### Sample Request

{% tabs %}
{% tab title="Sample Request" %}

```json
{
    "partnerReferenceNo": "2020102900000000000001",
    "bankCardToken": "thB9QgZkWx7asMCQG-QQO4hSwo6lAEN_cg5PEknI7mbwKCWIzR26QbXfytg",
    "merchantId": "99999",
    "amount":
    {
        "value": "10000.00",
        "currency": "IDR"
    },
    "validUpTo": "2024-09-19T13:44:11+07:00",
    "additionalInfo":
    {
        "channelCode": "713",
        "billDate": "2024-09-18T09:44:11+07:00",
        "billDescription": "SNAP Transaction",
        "phoneNo": "081274657847",
        "route":
        [
            {
                "owner": "26100253"
            },
            {
                "partnerId": "29195827",
                "partnerAmount": "4000.00"
            },
            {
                "partnerId": "andre-121321346",
                "partnerAmount": "5000.00"
            }
        ]
    }
}

```

{% endtab %}
{% endtabs %}

## Response Parameter

Response parameters are parameters that will be delivered by Faspay system in response to the request that have been sent by the merchant system. If no parameters appropriate/value are incorrect, the transaction will be rejected in the system Faspay.

<table><thead><tr><th width="279">SNAP Parameter</th><th width="145">Data Type</th><th width="105">M/O/C</th><th>Description</th></tr></thead><tbody><tr><td>responseCode</td><td>String (7)</td><td>M</td><td>Response code. In details here.</td></tr><tr><td>responseMessage</td><td>String (150)</td><td>M</td><td>Response description. In details here.</td></tr><tr><td>referenceNo</td><td>String (16)</td><td>M</td><td>Transaction identifier on service provider system. Must be filled upon successful transaction</td></tr><tr><td>partnerReferenceNo</td><td>String (32)</td><td>M</td><td><p>Transaction identifier on</p><p>service consumer system</p></td></tr><tr><td>webRedirectUrl</td><td>String (256)</td><td>C</td><td>Returns a universal link to PJP AIS Payment page. This link is recommended when the Client is unable to implement a check for whether PJP AlS app is installed on the user's device before redirect.</td></tr><tr><td>additionalInfo</td><td>Object</td><td>O</td><td>Additional information</td></tr><tr><td>    merchantId</td><td>String (5)</td><td>M</td><td><p>Merchant</p><p>identifier that is unique per each merchant</p></td></tr><tr><td>    webUrl</td><td>String (256)</td><td>C</td><td>The redirect url for the next process, available only on JSON format</td></tr><tr><td>    amount</td><td>Object</td><td>M</td><td>An object that contains information about an amount or value within a specific context.</td></tr><tr><td>           value</td><td>String (ISO4217) (16,2)</td><td>M</td><td>Net amount of the transaction. If it's IDR then value includes 2 decimal digits. e.g. IDR 10.000,- will be placed with 10000.00</td></tr><tr><td>          currency</td><td>String (3)</td><td>M</td><td>Currency</td></tr><tr><td><p> </p><p> </p><p>    phoneNo</p></td><td>String (30)</td><td>C</td><td><p>Customer Phone Number</p><p></p><p><strong>Notes:</strong> Mandatory for payment channel OVO Tokenized</p></td></tr><tr><td>    route</td><td>Object</td><td>O</td><td> </td></tr><tr><td>           owner</td><td>Alphanumeric (32) </td><td>O</td><td><p>Registered partner id that owns/generates the transaction. </p><p> </p><p><strong>Notes:</strong></p><ul><li>1 transaction only can contain 1 owner. </li><li>If null, then the remaining transaction amount will belong to the merchant’s Sendme balance. </li></ul></td></tr><tr><td>         partnerId</td><td>Alphanumeric (32) </td><td>O</td><td>Merchant partner id number.</td></tr><tr><td>         partnerAmount</td><td>Numeric (15) </td><td>C</td><td>Disbursement amount to partner.  </td></tr></tbody></table>

### Sample Response

{% tabs %}
{% tab title="Sample Response" %}

```json
{
    "responseCode": "2005400",
    "responseMessage": "Request has been processed successfully",
    "referenceNo": "7139999977485726",
    "partnerReferenceNo": "2020102900000000000001",
    "webRedirectUrl": "https://debit-sandbox.faspay.co.id/pws/100003/0830000010100000/a32c3d417ec84d6e977484ab02192d26fd58563a?trx_id=7139999977485726&merchant_id=99999&bill_no=2020102900000000000001",
    "additionalInfo":
    {
        "merchantId": "99999",
        "webUrl": "https://id.uat.shp.ee/sppay_checkout_id?type=start&mid=265&target_app=shopee&medium_index=dFhkbmR1bTBIamhWlQPIZ0f7oKyc375eB2Pjxn0JFJYoIBfgOBAkou7PiN4gUSFdmALU6A&order_key=fGzalBB7xwdgcDLM5YUuqH6nQj8GTXSy404zjUBi38c6M_ynHIOnnqGCKvoKvV1u2I2vcIUDCOX2XQ&order_sn=157320763472767665&return_url=aHR0cHM6Ly9kZWJpdC1zdGFnaW5nLmZhc3BheS5jby5pZC9wd3Mvc2hvcGVlL3JldHVyblVybD9hbW91bnQ9MTAwMDAwMCZjbGllbnRfaWQ9RmFzcGF5JnJlZmVyZW5jZV9pZD03MTM5OTk5OTc3NDg1NzI2LTc3NTQ3OTMmcmVzdWx0X2NvZGU9MjAzJnNpZ25hdHVyZT1rN1JNSWZ0Yl9jRWMzLUllTVU3dk9yNEszNExvZ1U2NC1sU1dUME03aFpzJTNEJnRyeF91aWQ9NzEzOTk5OTk3NzQ4NTcyNg%3D%3D&source=web&token=dFhkbmR1bTBIamhWlQPIZ0f7oKyc375eB2Pjxn0JFJYoIBfgOBAkou7PiN4gUSFdmALU6A",
        "amount":
        {
            "value": "10000.00",
            "currency": "IDR"
        },
        "phoneNo": "081274657847",
        "route":
        [
            {
                "owner": "26100253"
            },
            {
                "partnerId": "29195827",
                "partnerAmount": "4000.00"
            },
            {
                "partnerId": "andre-121321346",
                "partnerAmount": "5000.00"
            }
        ]
    }
}

```

{% endtab %}
{% endtabs %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.faspay.co.id/merchant-integration/api-reference-1/route-payment/snap-direct-debit.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
